#ifndef BMP085_pressure_H_
#define BMP085_pressure_H_

#include "lpc17xx.h"
#include "i2c.h"
#include "utility.h"
#define BMP085 			0xEE
#define BMP085_Pres 	0x34
#define BMP085_Temp 	0x2E
#define BMP085_Rd_MSB 	0xF6
#define BMP085_Rd_LSB 	0xF7
#define BMP085_Rd_XLSB 	0xF8
#define BMP085_Ctrl 	0xF4

#define ultra_low_power	0
#define standard		1
#define high_resolution	2
#define ultra_high_res	3
#define OSS				ultra_high_res

void demo_pressure(void);
void demo_pressureGuy(void);
void BMP085_Calibration(void);
unsigned int UncompensatedTemp(void);
unsigned int UncompensatedPressure(void);
int Temperature(void);
int Pressure(void);
float altitude(void);

#endif /* PRESSURE_H_ */
