/*
 * PID.h
 */
#ifndef PID_H_
#define PID_H_
#include "lpc17xx.h"
#include "L3G4200D_gyroscope.h"
#include "MMA7455_accelerometer.h"
#include "utility.h"
#include <stdio.h>
#include "usb_cdc.h"
#include "radio.h"
#include "leds.h"
#include "motor.h"

//Global variables READ ONLY
float g_RollError, g_PitchError, g_YawError,g_Previous_Roll_Error;
float g_setpoint_thrust;
float g_print_rate;
int recording;
float g_PID_Roll_Error ,g_PID_Roll_Error_Integral;

//The following are updated by Integrate_PID_Error()
float g_roll_integral,g_pitch_integral,g_yaw_integral;
//The following are updated by Derivative_PID_Error()
float g_roll_derivative,g_pitch_derivative,g_yaw_derivative;
//PID results
float PsetRoll, PsetPitch, PsetYaw;
float IsetRoll, IsetPitch, IsetYaw;
float DsetRoll, DsetPitch, DsetYaw;

void 	*PID_callback;							//define function pointer
volatile char toggle2;
float Kp,Ki,Kd;

void demo_testbed(void);
void demo_PID(void);
void Init_PID(void * fct);
void PID(void);
void Update_PID_Error(void);
void Integrate_PID_Error(void);
void Derivative_PID_Error(void);
void Mixer(void);
void TestBed(void);
#endif /* PID_H_ */
