#ifndef BATTERY_H_
#define BATTERY_H_

#include "utility.h"
#include "LPC17xx.h"
#include "leds.h"

#define BatteryLowAlarm		3.1f
#define r9 					9090.0f
#define r10 				35700.0f
#define mVperCount			(float)(3.27/4096.0)

void 	*battery_alarm_callback;	//define function pointer
volatile char toggle;

void Init_battery_alarm(void * fct);
void battery_alarm(void);
void adcInit(void);					//Initialise the analog to digital converter
int adcRead(int channel);			//Read a 12bit result from the ADC
float battery_voltage0(void);		//Measure the logic battery voltage
float battery_voltage1(void);		//Measure the motor battery voltage
#endif /* BATTERY_H_ */
