#include "lpc17xx.h"
#include "compass.h"
#include <stdio.h>
#include "i2c.h"
#include "utility.h"
#include "usb_cdc.h"
#include "leds.h"

volatile unsigned long int time_to_print_compass;

void demo_compass(void)
{
	unsigned long int previous_time;
	float interval;

	Init_compass();								//Enable compass
	while(1) {
		delay_ms(1);
		interval = (float)(LPC_TIM0->TC - previous_time) / 1000000;
		previous_time = LPC_TIM0->TC;
		if(LPC_TIM0->TC > time_to_print_compass){
			time_to_print_compass = LPC_TIM0->TC + 300000;  // .3 second interval
			printf("%5d%  5d%  5d\r\n", Compass_X,Compass_Y,Compass_Z);
		}
		if(RxReady()){return;}
	}
}

void Init_compass(void)
{
	i2c0_write(COMPASS_ADDRESS,0, SampleAveraging_8<<5 | DataOutputRate_75HZ<<2 | NormalOperation);
	i2c0_write(COMPASS_ADDRESS,1, magGain);
	i2c0_write(COMPASS_ADDRESS,2, ContinuousConversion);
}

signed short int Compass_X(void)
{
	return (signed short int) ( i2c0_read(COMPASS_ADDRESS,DataOutputXLSB) | i2c0_read(COMPASS_ADDRESS,DataOutputXMSB)<<8);
}

signed short int Compass_Y(void)
{
	return (signed short int) ( i2c0_read(COMPASS_ADDRESS,DataOutputZLSB ) | i2c0_read(COMPASS_ADDRESS,DataOutputZMSB)<<8);
}

signed short int Compass_Z(void)
{
	return (signed short int) ( i2c0_read(COMPASS_ADDRESS,DataOutputYLSB) | i2c0_read(COMPASS_ADDRESS,DataOutputYMSB)<<8);
}


