#include "leds.h"

char g_ledstater,g_ledstateg,g_ledstateb;

//Demo LED toggling
void demo_leds(void)
{
	leds_init();
	leds_all_off();
	while(1) {
		ledr(1);
		delay_ms(250);
		ledg(1);
		delay_ms(250);
		ledr(0);
		delay_ms(250);
		ledg(0);
		if(RxReady()){return;}
	}
}

void IMU_LED_test(void){
char red_level,green_level,blue_level;
char input,exit;
	red_level = 0;
	green_level = 0;
	blue_level = 0;
	printf("IMU LED test.");
	while(1){
		exit = 0;
		switch (input = get_char()){
		case 'R':
		case 'r':
			put_char('\n');
			put_char(input);
			while(1){
				switch (get_char()){
					case '+':
						if(red_level >= 245){red_level = 245;};
						red_level += 10;
						break;
					case '-':
						if(red_level <= 10){red_level = 10;};
						red_level -= 10;
						break;
					default:
						exit = 1;
						break;
				};
				printf(" %d",red_level);
				i2c0_write(IMU, RED, red_level);
				if(exit){break;};
			};
			break;
		case 'G':
		case 'g':
			put_char('\n');
			put_char(input);
			while(1){
				switch (get_char()){
					case '+':
						if(green_level >= 245){green_level = 245;};
						green_level += 10;
						break;
					case '-':
						if(green_level <= 10){green_level = 10;};
						green_level -= 10;
						break;
					default:
						exit = 1;
						break;
				};
				printf(" %d",green_level);
				i2c0_write(IMU, GREEN,green_level);
				if(exit){break;};
			}
			break;
		case 'B':
		case 'b':
			put_char('\n');
			put_char(input);
			while(1){
				switch (get_char()){
					case '+':
						if(blue_level >= 245){blue_level = 245;};
						blue_level += 10;
						break;
					case '-':
						if(blue_level <= 10){blue_level = 10;};
						blue_level -= 10;
						break;
					default:
						exit = 1;
						break;
				};
				printf(" %d",blue_level);
				i2c0_write(IMU, BLUE, blue_level);
				i2c0_write(IMU, BLUE, blue_level);
				i2c0_write(IMU, BLUE, blue_level);
				printf("1) %d %d",blue_level,i2c0_read(IMU, BLUE));
				printf("2) %d %d",blue_level,i2c0_read(IMU, BLUE));
				printf("3) %d %d",blue_level,i2c0_read(IMU, BLUE));
				if(exit){break;};
			}
			break;
		case 'x':
			printf("\nLeaving test");
			return;
		}
	}
}


// Function to initialise GPIO to access the user LEDs
void leds_init(void)
{
	set_pin_function (2, 0 , GPIO );	//P2_0 RED, GPIO
	set_pin_function (2, 1 , GPIO );	//P2_1 GREEN, GPIO
	set_pin_function (2, 2 , GPIO );	//P2_2 BLUE, GPIO
	LPC_GPIO2->FIODIR |= LED_ALL;		//Set GPIO to output
}

// Function to turn all leds on
void leds_all_on(void)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	LPC_GPIO2->FIOCLR = LED_ALL;		//all on, common anode
}

// Function to turn all leds off
void leds_all_off(void)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	LPC_GPIO2->FIOSET = LED_ALL;		//all off, common anode
}

// Function to turn on chosen led(s)
void led_on(unsigned int ledstate)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	// (ANDing to ensure we only affect the LED outputs)
	LPC_GPIO2->FIOCLR = ledstate & LED_ALL;
}

// Function to turn off chosen led(s)
void led_off(unsigned int ledstate)
{
	// (ANDing to ensure we only affect the LED outputs)
	LPC_GPIO2->FIOSET = ledstate & LED_ALL;
}


// Set Red led on or off
void ledr(char ledstate)
{
	i2c0_write(IMU, RED, ledstate);
}

// Set Green led on or off
void ledg(char ledstate)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	if(ledstate){
		LPC_GPIO2->FIOSET = LED_g;
	}else{
		LPC_GPIO2->FIOCLR = LED_g;
	}
	g_ledstateg = ledstate;
}

// Set Blue led on or off
void ledb(char ledstate)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	if(ledstate){
		LPC_GPIO2->FIOSET = LED_b;
	}else{
		LPC_GPIO2->FIOCLR = LED_b;
	}
	g_ledstateb = ledstate;
}

void toggleledr(void)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	if(g_ledstater){
		LPC_GPIO2->FIOCLR = LED_r;
		g_ledstater = 0;
	}else{
		LPC_GPIO2->FIOSET = LED_r;
		g_ledstater = 1;
	}
}

void toggleledg(void)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	if(g_ledstateg){
		LPC_GPIO2->FIOCLR = LED_g;
		g_ledstateg = 0;
	}else{
		LPC_GPIO2->FIOSET = LED_g;
		g_ledstateg = 1;
	}
}

void toggleledb(void)
{
	LPC_GPIO2->FIOMASK  = 0;			//clear mask
	if(g_ledstateb){
		LPC_GPIO2->FIOCLR = LED_b;
		g_ledstateb = 0;
	}else{
		LPC_GPIO2->FIOSET = LED_b;
		g_ledstateb = 1;
	}
}

