#ifndef LEDS_H_
#define LEDS_H_

#include "LPC17xx.h"
#include "utility.h"
#include "usb_cdc.h"

//I2C address and registers
#define RED					0x00
#define GREEN				0x01
#define BLUE				0x02

// Defines for IMU user leds
#define LED_r (1 << 0)				// Led_r is P2_0
#define LED_g (1 << 1) 				// Led_g is P2_1
#define LED_b (1 << 2) 				// Led_b is P2_2
#define LED_ALL (LED_r | LED_g | LED_b)
//Public
void demo_leds(void);				//blink the two leds every quarter second
void IMU_LED_test(void);
void leds_init(void);				//setup the I/O port to output LED values
void leds_all_on(void);				//Turn on both LEDs
void leds_all_off(void);			//Turn off both LEDs
void leds_invert(void);				//Toggle both LED states
void ledr(char ledstate);			//Turn LED on when ledstate = 1
void ledg(char ledstate);			//Turn LED off when ledstate = 0
void ledb(char ledstate);			//
void toggleledr(void);
void toggleledg(void);
void toggleledb(void);
void led_on(unsigned int ledstate);
void led_off(unsigned int ledstate);
#endif /*LEDS_H_*/
