#include "motor.h"

//Demo motor
//Wait for terminal character from 0 to 9 and set the front motor
//to this value 0-90% in 10% steps
void demo_motor(void)
{
	char speed;
	while(1) {
		speed = get_char();
		put_char(speed);
		if(speed>=0x30 && speed<=0x39){
			speed = 10*(speed-0x30);
			motor_front(speed);
		}
		if(RxReady()){return;};
	}
}

void IMU_ESC_test(void){
char ESC0_level,test;
char input,exit;
	ESC0_level = 0;
	printf("IMU ESC test.");
	while(1){
		exit = 0;
		switch (input = get_char()){
		case '0':
			printf("\nESC0 ");
			while(1){
				switch (get_char()){
					case '+':
						if(ESC0_level >= 245){ESC0_level = 245;};
						ESC0_level += 10;
						break;
					case '-':
						if(ESC0_level <= 10){ESC0_level = 10;};
						ESC0_level -= 10;
						break;
					default:
						exit = 1;
						break;
				};
				printf(" %d",ESC0_level);
				i2c0_write(IMU, ESC0H, 0x00);
			//	i2c0_write(IMU, ESC0L, 0x77);
				i2c0_write(IMU, RED, test++);
				i2c0_write(IMU, ESC0L, ESC0_level);

				printf("\nRead Red IMU LED 0x%x\n",i2c0_read(IMU, RED));

				printf("\nRead ESC0 IMU High 0x%x\n",i2c0_read(IMU, ESC0H));
				printf("\nRead ESC0 IMU Low  0x%x\n",i2c0_read(IMU, ESC0L));
				if(exit){break;};
			};
			break;
		case 'x':
			printf("\nLeaving test");
			return;
		}
	}
}

//The four motor control routines set the ESC motor speed as a percentage from
//0 to 100%. The percentage fine tunes the ESC control pulses to within 1us.
void motor_front(float percent){
	i2c0_write(IMU, ESC0H, (uint32_t)(percent*10)>>8);
	i2c0_write(IMU, ESC0L, (uint32_t)(percent*10)&0xff);
	g_motor_front = percent;
}
void motor_rear(float percent){
	i2c0_write(IMU, ESC1H, (uint32_t)(percent*10)>>8);
	i2c0_write(IMU, ESC1L, (uint32_t)(percent*10)&0xff);
	g_motor_rear = percent;
}
void motor_left(float percent){
	i2c0_write(IMU, ESC2H, (uint32_t)(percent*10)>>8);
	i2c0_write(IMU, ESC2L, (uint32_t)(percent*10)&0xff);
	g_motor_left = percent;
}
void motor_right(float percent){
	i2c0_write(IMU, ESC3H, (uint32_t)(percent*10)>>8);
	i2c0_write(IMU, ESC3L, (uint32_t)(percent*10)&0xff);
	g_motor_right = percent;
}
void motors_off(void){
	motor_front(0);
	motor_rear(0);
	motor_left(0);
	motor_right(0);
}
void motors_all(float percent){
	motor_front(percent);
	motor_rear(percent);
	motor_left(percent);
	motor_right(percent);
}
