#ifndef MOTOR_H_
#define MOTOR_H_
#include "lpc17xx.h"
#include "utility.h"
#include "usb_cdc.h"
#include "radio.h"

#define	IMU					0x4e

//I2C address and registers
#define IODIR 				0x03
#define IMU_IO	 			0x04
#define ADC_1				0x05
#define ADC_2				0x06
#define ESC0L				0x07
#define ESC0H				0x08
#define ESC1L				0x09
#define ESC1H				0x0A
#define ESC2L				0x0B
#define ESC2H				0x0C
#define ESC3L				0x0D
#define ESC3H				0x0E


//Global motor speeds read only
float g_motor_front,g_motor_rear,g_motor_left,g_motor_right;

//Public
void demo_motor(void);				//demonstrate motor drive
void IMU_ESC_test(void);
void motor_front(float percent);	//Set motor speed 0..100%
void motor_rear(float percent);		//Set motor speed 0..100%
void motor_left(float percent);		//Set motor speed 0..100%
void motor_right(float percent);	//Set motor speed 0..100%
void motors_all(float percent);		//Set motor speed 0..100%
void motors_off(void);
#endif /* MOTOR_H_ */
