#include "radio.h"

// Print radio pulse widths once a second
void demo_radio(void)
{
	while(1){
		delay_ms(1000); 					// 1 second interval
		printf("%5u, %5u, %5u, %5u    ",g_pulse1, g_pulse2, g_pulse3, g_pulse4);
		printf("R%4d, P%4d, T%4d, Y%4d\n", roll_stick(), pitch_stick(),\
				throttle_stick(), yaw_stick());
		if(RxReady()){return;}
	}
}

// get roll stick position (-50 to 50)
float roll_stick()
{
	return (float)(i2c0_read(IMU, RadioRollH)<<8 | i2c0_read(IMU, RadioRollL));
}
//  get pitch stick position (-50 to 50)
float pitch_stick()
{
	return (float)(i2c0_read(IMU, RadioPitchH)<<8 | i2c0_read(IMU, RadioPitchL));
}

//  get yaw stick position (-50 to 50)
float yaw_stick()
{
	return (float)(i2c0_read(IMU, RadioYawH)<<8 | i2c0_read(IMU, RadioYawL));
}

//  get throttle stick position (0 to 100)
float throttle_stick()
{
	return (float)(i2c0_read(IMU, RadioThrustH)<<8 | i2c0_read(IMU, RadioThrustL));
}

