#ifndef RADIO_H_
#define RADIO_H_

#include "lpc17xx.h"
#include "i2c.h"
#include "utility.h"
#include <stdio.h>
#include "usb_cdc.h"

//I2C address and registers
#define RadioPitchL			0x0F
#define RadioPitchH			0x10
#define RadioRollL			0x11
#define RadioRollH			0x12
#define RadioYawL			0x13
#define RadioYawH			0x14
#define RadioThrustL		0x15
#define RadioThrustH		0x16

// Global variables
unsigned int g_pulse1; // for radio
unsigned int g_pulse2;
unsigned int g_pulse3;
unsigned int g_pulse4;

//Public
void demo_radio(void);				//Print radio pulse widths once a second
float roll_stick();					//get roll stick position (-50 to 50)
float pitch_stick();				//get pitch stick position (-50 to 50)
float yaw_stick();					//get yaw stick position (-50 to 50)
float throttle_stick();				//get throttle stick position (0 to 100)

#endif /* RADIO_H_ */
