#ifndef UART_H_
#define UART_H_

#include "lpc17xx.h"

#define PCUART1_POWERON (1 << 4)	//PCON bit 4 enables UART1 power
#define PCLK_UART1 		8
#define PCLK_UART1_MASK (3 << 8)

#define PCUART3_POWERON (1 << 25)	//PCON bit 25 enables UART3 power
#define PCLK_UART3 		18
#define PCLK_UART3_MASK (3 << 18)

#define LSR_RDR		0x01
#define LSR_THRE	0x20

//Public
void demo_uart(void);				//
void UART1_Init(int baudrate);		//Enable UART1 with 8bit no parity
void UART3_Init(int baudrate);		//Enable UART3 with 8bit no parity
void putchar1(unsigned char c);		//send one character to UART1
void putchar3(unsigned char c);		//send one character to UART3
unsigned char getchar1();			//read one character from UART1
char rx_ready1();					//return 1 when data is ready
unsigned char getchar3();			//read one character from UART3
char rx_ready3();					//return 1 when data is ready
void PrintString1(char *pcString);	//
void PrintString3(char *pcString);	//
#endif /* UART_H_ */
