#ifndef USB_CDC_H_
#define USB_CDC_H_
#include <string.h>			// memcpy
#include "LPC17xx.h"
#include "usbapi.h"
#include "usbdebug.h"
#include "serial_fifo.h"
#include "type.h"
#include "descriptor.h"

#define UART1	0
#define UART3  	1
#define CDC		2
void 			*putchar_callback;			//define function pointers
unsigned char	(*getchar_callback)();		//used by printf
char 			(*rx_ready_callback)();		//

U8 abBulkBuf[64];
U8 abClassReqData[8];
//Public
void Init_Com_Drivers(void * putchar,unsigned  char (*getchar)(),char (*rx_ready)());
void Set_printf_IO(char device,int baudrate);
void CDC_Init(void);				//Initialise USB CDC class as a serial port
int USB_putchar(int c);				//Send a character to the USB CDC
unsigned char USB_getchar(void);				//Get a character from the USB CDC
char USB_RxReady(void);
char RxReady(void);
//Private
void USBIntHandler(void);			//
void BulkOut(U8 bEP, U8 bEPStatus);
void BulkIn(U8 bEP, U8 bEPStatus);
BOOL HandleClassRequest(TSetupPacket *pSetup, int *piLen, U8 **ppbData);
void VCOM_init(void);
int __sys_write(int iFileHandle, char *pcBuffer, int iLength);
int __sys_readc (void);
void __sys_writec(char data);
void USB_IRQHandler(void);
void USBFrameHandler(U16 wFrame);
void enable_USB_interrupts(void);

void put_char(char data);
char get_char(void);

#endif /* USB_CDC_H_ */
