#ifndef UTILITY_H_
#define UTILITY_H_
#include "LPC17xx.h"
#include "usb_cdc.h"
#include "battery.h"
#include "PID.h"

int g_ADC;
float g_ADC_P30,g_ADC_M30;

#define CLAMP(x, min, max) {if (x <= min) x = min; else if (x >= max) x = max;}

volatile int current_time;				//holds the current Ms count of SysTick
#define GPIO 			0
#define SECOND_FUNCTION 1
#define THIRD_FUNCTION 	2
#define FORTH_FUNCTION 	3

#define ON				1
#define OFF				0

#ifdef DEBUG
#define debug1(string,...);	printf(string,__VA_ARGS__)
#else
#define debug1(string,...);	//this compiles to no code for all optimizations
#endif

float Trace0[1000],Trace1[1000],Trace2[1000],Trace3[1000],Trace4[1000];

//Public
void delay_ms(int interval);			//Timed loop waiting for a the requested interval to elapse on the sys_clock
signed short median(signed short m[], int n);
void output_low(int port, int bit);		//Set an I/O pin low
void output_high(int port, int bit);	//Set an I/O pin high
int input(int port, int bit);			//Read the state of an I/O pin
unsigned int get_bits(unsigned int reg ,unsigned int offset, unsigned intwidth);
void set_bits(volatile unsigned int *reg, unsigned int offset, unsigned int width, unsigned int value);
void set_pin_function(unsigned int port, unsigned int pin,  unsigned int function);
char GetHex(void);
int ReadHex(void);
float Reference_Angle(void);
void TraceResults(float dt);
void PrintTraceResults(void);
#endif /* UTILITY_H_ */
