#include "LPC17xx.h"
#include "leds.h"

// Function to initialise GPIO to access the user LEDs
void leds_init (void)
{
	// Set P1_24, P1_25, P1_28, P1_29 to 00 - GPIO
	LPC_PINCON->PINSEL3	&= (~0x0F0F0000);	
	LPC_GPIO2->FIODIR |= LED_ALL;	// Set GPIO to outputs
}


// Function to turn all leds on
void leds_all_on (void)
{
	LPC_GPIO2->FIOSET = LED_ALL;
}

// Function to turn all leds off
void leds_all_off (void)
{
	LPC_GPIO2->FIOCLR = LED_ALL;
}

// Function to turn on chosen led(s)
void led_on (unsigned int ledstate)
{
	// Turn on requested LEDs
	// (ANDing to ensure we only affect the LED outputs)
	LPC_GPIO2->FIOSET = ledstate & LED_ALL;
}

// Function to turn off chosen led(s)
void led_off (unsigned int ledstate)
{
	// Turn off requested LEDs
	// (ANDing to ensure we only affect the LED outputs)
	LPC_GPIO2->FIOCLR = ledstate & LED_ALL;
}
